(require (planet "memoize.ss" ("dherman" "memoize.plt" 2 1)))

(define/memo (collatz n)
  (cond ((= n 1) 1)
        ((even? n) (add1 (collatz (/ n 2))))
        (else (add1 (collatz (add1 (* 3 n)))))))

(let ((m -1) (the-number #f))
  (let loop ((n 1))
    (when (< n 1000000)
      (when (> (collatz n) m)
        (set! m (collatz n))
        (set! the-number n))
      (loop (add1 n))))
  the-number)